	#include "TI-85.h"

	.org	0

	.db	"Puyo Puyo",0

PUYOMINX = 0
PUYOMINY = 0

RANDOMNUMBER = TEXT_MEM


Main:
	;ld a,(CONTRAST) ; put contrast in register b
	;ld b,a
	;CALL_(FadeOut)
Menu:
	CALL_(ClearScreen)

	ld a, 12
	ld (CURSOR_X), a
	ld a, 0
	ld (CURSOR_Y), a
	ld b, 22	; it's 12 letters
	ld de, (PROGRAM_ADDR)
	ld hl, TitleText1
	add hl, de
	ROM_CALL(D_LM_STR)

	ld a, 12
	ld (CURSOR_X), a
	ld a, 8
	ld (CURSOR_Y), a
	ld b, 10	
	ld de, (PROGRAM_ADDR)
	ld hl, HighScoreText
	add hl, de
	ROM_CALL(D_LM_STR)

	ld ix, (PROGRAM_ADDR)
	ld de, HighestScore
	add ix, de
	ld h, (ix)
	ld l, (ix+1)

	ld a, 1
	ld (CURSOR_ROW), a
	ld a, 8
	ld (CURSOR_COL), a
	ROM_CALL(D_HL_DECI) ; draw value in HL on screen

	ld a, 12
	ld (CURSOR_X), a
	ld a, 16
	ld (CURSOR_Y), a
	ld b, 6	
	ld de, (PROGRAM_ADDR)
	ld hl, WidthText
	add hl, de
	ROM_CALL(D_LM_STR)

	ld ix, (PROGRAM_ADDR)
	ld de, PuyoMaxY
	add ix, de
	ld l, (ix)
	ld h, 0
	

	ld a, 2
	ld (CURSOR_ROW), a
	ld a, 8
	ld (CURSOR_COL), a
	ROM_CALL(D_HL_DECI) ; draw value in HL on screen

	ld a, 12
	ld (CURSOR_X), a
	ld a, 24
	ld (CURSOR_Y), a
	ld b, 6	
	ld de, (PROGRAM_ADDR)
	ld hl, SpeedText
	add hl, de
	ROM_CALL(D_LM_STR)

	ld ix, (PROGRAM_ADDR)
	ld de, PuyoSpeed
	add ix, de
	ld l, (ix)
	ld h, 0
	

	ld a, 3
	ld (CURSOR_ROW), a
	ld a, 8
	ld (CURSOR_COL), a
	ROM_CALL(D_HL_DECI) ; draw value in HL on screen

	ld a, 12
	ld (CURSOR_X), a
	ld a, 32
	ld (CURSOR_Y), a
	ld b, 20
	ld de, (PROGRAM_ADDR)
	ld hl, SpeedText2
	add hl, de
	ROM_CALL(D_LM_STR)

	ld a, 12
	ld (CURSOR_X), a
	ld a, 40
	ld (CURSOR_Y), a
	ld b, 21
	ld de, (PROGRAM_ADDR)
	ld hl, SpeedText3
	add hl, de
	ROM_CALL(D_LM_STR)

	ld a, 12
	ld (CURSOR_X), a
	ld a, 48
	ld (CURSOR_Y), a
	ld b, 26
	ld de, (PROGRAM_ADDR)
	ld hl, ClearScreenText
	add hl, de
	ROM_CALL(D_LM_STR)

	ld a, 12
	ld (CURSOR_X), a
	ld a, 56
	ld (CURSOR_Y), a
	ld b, 24
	ld de, (PROGRAM_ADDR)
	ld hl, ContinueText
	add hl, de
	ROM_CALL(D_LM_STR)
	
MenuA:
	call GET_KEY
	cp K_PLUS
	jr nz, MenuB
	ld de, (PROGRAM_ADDR)
	ld hl, PuyoSpeed
	add hl, de
	inc (hl)
	JUMP_(Menu)
	
MenuB:
	cp K_MINUS
	jr nz, MenuC
	ld de, (PROGRAM_ADDR)
	ld hl, PuyoSpeed
	add hl, de
	dec (hl)
	JUMP_(Menu)
MenuC:
	cp K_CLEAR
	jr nz, MenuD
	CALL_(PuyoClear)
	jr maina
MenuD:

	cp K_LEFT
	jr nz, MenuE
	ld de, (PROGRAM_ADDR)
	ld hl, PuyoMaxY
	add hl, de
	ld a, 1
	cp (hl)
	jr z, MenuA	; if it's 1, don't go lower, just leave
	dec (hl)
	JUMP_(Menu)

MenuE:
	cp K_RIGHT
	jr nz, MenuF
	ld de, (PROGRAM_ADDR)
	ld hl, PuyoMaxY
	add hl, de
	ld a, 8
	cp (hl)
	jr z, MenuA	; if it's already 8, don't go higher, just leave
	inc (hl)
	JUMP_(Menu)
MenuF:


	cp K_EXIT
	jr z,mainend
	cp K_ENTER
	jr nz, MenuA

	CALL_(ClearScreen)
	CALL_(DisplayScore)
maina:
	
	
	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)
	ld hl, (PROGRAM_ADDR)
	ld de, PuyoSpeed
	add hl, de
	ld b, (hl) ; put the speed into b, since it's how many 256's we'll go through
	ld l, b
	ld h, 0
	
	add hl, hl ; double hl
	add hl, hl
	add hl, hl
	add hl, hl
	add hl, hl
	inc hl
	ld b, h
	ld c, l
WaitKey:
	dec bc
	ld hl, RANDOMNUMBER
	inc (hl)	; we use this as a random number generator
	inc (hl)
	inc (hl)
          call GET_KEY
	cp K_LEFT
	CALL_Z(FallingPGravity)
         	 cp K_UP
	CALL_Z(FallingPLeft)
         	 cp K_DOWN
	CALL_Z(FallingPRight)
	cp K_SECOND
	CALL_Z(RotatePuyoRight)
	cp K_ALPHA
	CALL_Z(RotatePuyoLeft)
	cp K_MORE
	JUMP_Z(Menu)
          cp K_EXIT
          jr z,mainend
	ld a, 0
	cp c
	jr nz, WaitKey
	cp b
	jr nz, WaitKey
	CALL_(FallingPGravity)
	jr maina
	

mainend:
         
	ld a, 1
	ld (ZS_BITS), a ; putting 1 into this address will cause the checksum to be
			; recalculated
		      ; thereby avoiding a "bad checksum" error in Zshell when stuff is changed
	ret

DropOjama:
	push bc
	push de
	push hl
	push ix

	
	ld de, (PROGRAM_ADDR)
	ld hl, HighScore
	add hl, de	; get the first byte of the score in hl
	ld b, (hl)
	ld ix, OjamaNumber
	add ix, de
	ld a, (ix)
	add a, b
	ld (ix), a
	cp 64	; check if it's over 64, it if is, drop ojamas
	jr c, DropOjamaEnd
	ld (ix), 0
	add a, -64
	and 00000111
	ld ix, PuyoMatrix
	add ix, de
	cp 0
	jr z, DropOjamaEnd	
DropOjamaA:

	ld (ix+15), 4
	ld (ix+31), 4
	ld (ix+47), 4
	ld (ix+63), 4
	ld (ix+79), 4
	ld (ix+95), 4
	ld (ix+111), 4
	ld (ix+127), 4
	dec a
	dec ix
	cp 0
	jr nz, DropOjamaA

	CALL_(PuyoGravity)
DropOjamaEnd:

	pop ix
	pop hl
	pop de
	pop bc
	ret

DeleteOjama: ; input: b-x c-y
	push bc
	push de
	push hl
	push ix

	ld de, (PROGRAM_ADDR)
	ld ix,  PuyoMatrix
	add ix, de
	ld de, 0
	ld a, c
	sla a
	sla a
	sla a
	sla a
	add a, b ;add in the (y*16)+b address into a
	ld e, a
	add ix, de ;now ix has the address of the puyo we're on, so we can index from it
	
	dec b
	CALL_(CheckPuyo)
	cp 4
	jr nz, DeleteOjamaUpper
	ld (ix-1), 255	; delete one left

DeleteOjamaUpper:
	inc b
	inc b
	CALL_(CheckPuyo)
	cp 4
	jr nz, DeleteOjamaLeft
	ld (ix+1), 255
DeleteOjamaLeft:
	dec b
	dec c
	CALL_(CheckPuyo)
	cp 4
	jr nz, DeleteOjamaRight
	ld (ix-16), 255
DeleteOjamaRight:
	inc c
	inc c
	CALL_(CheckPuyo)
	cp 4
	jr nz, DeleteOjamaEnd
	ld (ix+16), 255
DeleteOjamaEnd:

	pop ix
	pop hl
	pop de
	pop bc
	ret
GameOver: 
	push bc
	push de
	push hl	
	push ix
	
	ld ix, HighScore
	ld de, (PROGRAM_ADDR)
	ld hl, HighestScore
	add hl, de
	add ix, de
	ld a, (hl)
	cp (ix)
	jr z, GameOverC ;if it's the same, check the second byte
	jr nc, GameOverB ; if it's lower, just delete the score
	jr GameOverD	; otherwise, just go and put the current score in highest score
GameOverC:
	inc hl
	ld a, (hl)
	cp (ix+1)
	jr nc, GameOverB 	; if both bytes of ix (highscore) are bigger, put it in
	dec hl			; highest score (hl)
GameOverD:	
	ld a, (ix)
	ld (hl), a
	ld a, (ix+1)
	inc hl
	ld (hl), a	; put the current score in the high score
	
GameOverB:
	ld (ix), 0
	ld (ix+1), 0	; zero out the score

	CALL_(ClearScreen)
	CALL_(PuyoClear)
	
	
	ld bc, 0
	ld de, (PROGRAM_ADDR)
	ld hl, GameOverText
	add hl, de

	ld a, 3
	ld (CURSOR_ROW), a
	ld a, 6
	ld (CURSOR_COL), a
	ROM_CALL(D_LT_STR)
GameOverA:	
	call GET_KEY
	cp K_EXIT
        jr nz, GameOverA
	CALL_(ClearScreen)
	CALL_(DisplayScore)

	pop ix
	pop hl	
	pop de
	pop bc
	ret
PuyoClear:
	push bc
	push de
	push hl

	ld de, (PROGRAM_ADDR)
	ld hl, PuyoMatrix
	add hl, de
	ld a, 128
PuyoClearA:
	ld (hl), 255
	inc hl
	dec a
	cp 0
	jr nz, PuyoClearA
	ld ix, HighScore
	add ix, de
	ld (ix), 0
	ld (ix+1), 0

	pop hl
	pop de
	pop bc
	ret


DisplayScore:
	push bc
	push de
	push hl

	ld ix, (PROGRAM_ADDR)
	ld de, PuyoMaxY
	add ix, de
	ld a, (ix)
	cp 8
	jr z, DisplayScoreEnd	; if the screen is the full 8, don't display score

	
	ld a, 12
	ld (CURSOR_X), a
	ld a, 56
	ld (CURSOR_Y), a
	ld b, 10	
	ld de, (PROGRAM_ADDR)
	ld hl, ScoreText
	add hl, de
	ROM_CALL(D_LM_STR)
	

	ld ix, (PROGRAM_ADDR)
	ld de, HighScore
	add ix, de
	ld h, (ix)
	ld l, (ix+1)

	ld a, 7
	ld (CURSOR_ROW), a
	ld a, 11
	ld (CURSOR_COL), a
	ROM_CALL(D_HL_DECI) ; draw value in HL on screen
DisplayScoreEnd:
	pop hl
	pop de
	pop bc
	ret
PuyoScore: ; input: b- puyos cleared c- multiplier


	push bc
	push de
	push hl
	push ix

	ld h, 0
	ld l, b
	ld a, 0
	cp c
	jr z, PuyoScoreB ; if it's zero, keep going, otherwise, mulitply
PuyoScoreA:
	add hl, hl 	; this will double the score
	dec c
	ld a, 0
	cp c
	jr nz, PuyoScoreA ; if it's not yet zero, multipy again
	
PuyoScoreB:

	ld ix, (PROGRAM_ADDR)
	ld de, HighScore
	add ix, de
	ld d, (ix)
	ld e, (ix+1)
	add hl, de	; add old score to new score
	ld (ix), h
	ld (ix+1), l

	

	CALL_(DisplayScore)
	

	pop ix
	pop hl
	pop de
	pop bc
	ret
PuyoComboMatrix:
	push bc
	push de
	push hl		

	ld de, (PROGRAM_ADDR)
	ld ix, PuyoMaxY
	add ix, de

	ld de, 0
	ld bc, 0
PuyoComboMatrixA:
	ld a, 2 ; to indicate first run
	CALL_(PuyoCombo)
	ld a, h
	cp 4
	jr c, PuyoComboMatrixB ; if it's not enough, keep going
	add a, d
	ld d, a			; add the number of puyos cleared into d
	ld a, 3 ; to indicate first run and delete
	CALL_(PuyoCombo)

PuyoComboMatrixB
	inc b
	ld a, 16
	cp b
	jr nz, PuyoComboMatrixA
	ld b, 0
	inc c
	ld a, (ix)
	cp c
	jr nz, PuyoComboMatrixA ; if it's not PuyoMaxY (ix), we're not done yet

	CALL_(PuyoGravity) 	; get stuff to drop after the clear
	ld a, 0
	cp d			; check if puyo's were cleared
	jr z, PCMEnd		; if they weren't, leave, if they were, start again
	ld b, d
	ld c, e
	CALL_(PuyoScore)
	ld d, 0
	inc e			; increment e, since it's the multiplyer for the score
	ld bc, 0 		; start over since we changed positions
	jr PuyoComboMatrixA

PCMEnd:


	pop hl
	pop de
	pop bc
	ret

PuyoCombo: ;input: a- bit 0: 1 for delete combo, bit 1: 1 for first run b-x c-y 
	   ;output: h- number in combo

	push ix
	push bc
	push de
	push af ; so we can retrieve it later if needed
	push af ; a second layer that will keep the original safe

	push hl
	push af
	ld hl, RANDOMNUMBER
	inc (hl)	; we use this as a random number generator
	pop af
	pop hl

	bit 1, a	; check if it's the first run
	jr nz, PuyoComboFirst
	inc h		; if it isn't, increment h (where we keep number of puyos)
	jr PuyoComboStart
	
PuyoComboFirst:		; if it is, clear out h
	ld h, 1
	pop af
	and 00000001b ; take a, make sure only the 0 bit counts, and push it back
	push af

PuyoComboStart:

	CALL_(CheckPuyo)
	cp 255
	JUMP_Z(PuyoComboEnd) ; if nothing there, get outta here
	cp 4
	JUMP_Z(PuyoComboEnd) ; if it's an ojama puyo, get outta here
	ld l, a ; put the type of puyo to look for in l

	ld de, (PROGRAM_ADDR)
	ld ix, PuyoMatrix
	add ix, de
	ld de, 0
	ld e, b
	add ix, de
	ld de, 0
	ld e, c
	sla e
	sla e
	sla e
	sla e
	add ix, de ; get y*16 and x added into ix

	pop af
	push af
	cp 1	; check if we're deleting
	jr nz, PuyoComboA
	CALL_(DeleteOjama)
	ld (ix), 255
	jr PuyoComboLeft

PuyoComboA:
	
	ld e, 128 ; add 128 so that it doesn't get checked again in recursive mode
	ld a, (ix)
	add a, 128
	ld (ix), a
	
	

PuyoComboLeft:
	
	
	dec b ; so we check to the left
	CALL_(CheckPuyo)
	
	cp l ; compare to l, which is the type of the puyo we're on
	jr nz, PuyoComboRight
	pop af ; so we know whether to delete in the called instance of this function
	push af
	CALL_(PuyoCombo)

PuyoComboRight:
	inc b

	inc b ; so we check to the right
	CALL_(CheckPuyo)
	
	cp l ; compare to l, which is the type of the puyo we're on
	jr nz, PuyoComboUp
	pop af ; so we know whether to delete in the called instance of this function
	push af
	CALL_(PuyoCombo)

PuyoComboUp:
	dec b

	dec c ; so we check to the upper
	CALL_(CheckPuyo)
	
	cp l ; compare to l, which is the type of the puyo we're on
	jr nz, PuyoComboDown
	pop af ; so we know whether to delete in the called instance of this function
	push af
	CALL_(PuyoCombo)
PuyoComboDown:
	inc c

	inc c ; so we check to the lower
	CALL_(CheckPuyo)
	
	cp l ; compare to l, which is the type of the puyo we're on
	jr nz, PuyoComboCheck
	pop af ; so we know whether to delete in the called instance of this function
	push af
	CALL_(PuyoCombo)

PuyoComboCheck:
	dec c

	pop af
	push af
	cp 1
	jr z, PuyoComboEnd ;if we have deleted, we can move on
	res 7, (ix) 	   ; otherwise, take away 128 from the spot 


PuyoComboEnd:
	ld a, h
	pop af
	pop af
	
	pop de
	pop bc
	pop ix
	ret

PuyoGravity:
	push bc
	push de
	push hl

	ld b, 1
	ld c, 0
	ld de, (PROGRAM_ADDR)
	
	ld hl, PuyoMatrix
	add hl, de
	ld de, 0

PuyoGravityStart:

	inc hl
	ld a, (hl)
	cp 255
	jr z, PuyoGravityA ;if it's not a puyo, continue checking
	
	dec b	; decrease so we know where we're putting it
	CALL_(CheckPuyo)
	inc b	; and remember to bring it back up
	cp 255
	jr nz, PuyoGravityA ; if it's not 255-nothing there, then continue checking
	ld a, (hl)	; otherwise, take the data in (hl) and put it one x lower
	ld (hl), 255    
	dec hl
	ld (hl), a
	inc hl
	ld d, 1 ; set d as 1 if something was done, so we can check later
	
	
PuyoGravityA:
	inc b
	ld a, b
	cp 16
	jr nz, PuyoGravityStart ; if it's not 16, then continue till it is
	CALL_(DisplayPMatrix)	; just in case we want to see it in action
	ld a, d
	cp 1
	jr nz, PuyoGravityB	; if something has been done, go through one more time
	ld d, 0
	ld b, 1
	push de
	ld de, -15		; subtract 14 to get hl on the x=1 puyo
	add hl, de
	pop de
	jr PuyoGravityStart 	; and continue on again

PuyoGravityB:
	inc c
	ld a, c
	cp 8
	jr z, PuyoGravityEnd ;check if we're done, if not, continue in the next column
	ld b, 1
	inc hl	; increment hl, since we skip the lowest puyo in each column
	jr PuyoGravityStart
	
PuyoGravityEnd:
	
	pop hl
	pop de
	pop bc
	ret

DisplayPMatrix:
	push bc
	push de
	push hl
	push ix
	
	ld ix, (PROGRAM_ADDR)
	ld de, PuyoMaxY
	add ix, de	; get PuyoMaxY into (ix)

	
	ld bc, 0
DPMStart:
	ld de, (PROGRAM_ADDR)
	ld hl, PuyoMatrix
	add hl, de
	ld a, b
	sla a
	sla a
	sla a
	sla a
	add a, c
	ld e, a
	ld d, 0
	add hl, de ;add the bc counter into hl for final location
	push hl	   ; save it for later
	ld de, 128
	ld hl, 0
	ld a, b
DPMA:	
	cp 0
	jr z, DPMB
	add hl, de
	dec a
	jr DPMA
	
DPMB:
	ld d, 0
	ld e, c
	add hl, de 
	ld d, h
	ld e, l 	; put the distance forward in video memory in de
	pop hl
	ld a, (hl)
	cp 0
	jr z, DPMC
	cp 1
	jr z, DPMD
	cp 2
	jr z, DPM2
	cp 3
	jr z, DPM3
	cp 4
	JUMP_Z(DPM4)
	JUMP_(DPME)
DPMC:
	ld hl, VIDEO_MEM
	add hl, de
	ld de, 16
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	add hl, de
	ld (hl), $ff
	JUMP_(DPMF)

DPMD:
	ld hl, VIDEO_MEM
	add hl, de
	ld de, 16
	ld (hl), 11000011b
	add hl, de
	ld (hl), 11100111b
	add hl, de
	ld (hl), 00111100b
	add hl, de
	ld (hl), 00011000b
	add hl, de
	ld (hl), 00011000b
	add hl, de
	ld (hl), 00111100b
	add hl, de
	ld (hl), 11100111b
	add hl, de
	ld (hl), 11000011b
	JUMP_(DPMF)
DPM2:
	ld hl, VIDEO_MEM
	add hl, de
	ld de, 16
	ld (hl), 00011000b
	add hl, de
	ld (hl), 00111100b
	add hl, de
	ld (hl), 01100110b
	add hl, de
	ld (hl), 11000011b
	add hl, de
	ld (hl), 11000011b
	add hl, de
	ld (hl), 01100110b
	add hl, de
	ld (hl), 00111100b
	add hl, de
	ld (hl), 00011000b
	jr DPMF
DPM3:
	ld hl, VIDEO_MEM
	add hl, de
	ld de, 16
	ld (hl), 00000000b
	add hl, de
	ld (hl), 01111110b
	add hl, de
	ld (hl), 01000010b
	add hl, de
	ld (hl), 01000010b
	add hl, de
	ld (hl), 01000010b
	add hl, de
	ld (hl), 01000010b
	add hl, de
	ld (hl), 01111110b
	add hl, de
	ld (hl), 00000000b
	jr DPMF
DPM4:

	ld hl, VIDEO_MEM
	add hl, de
	ld de, 16
	ld (hl), 10101010b
	add hl, de
	ld (hl), 01010101b
	add hl, de
	ld (hl), 10101010b
	add hl, de
	ld (hl), 01010101b
	add hl, de
	ld (hl), 10101010b
	add hl, de
	ld (hl), 01010101b
	add hl, de
	ld (hl), 10101010b
	add hl, de
	ld (hl), 01010101b
	jr DPMF
DPME:
	ld hl, VIDEO_MEM
	add hl, de
	ld de, 16
	ld (hl), $00
	add hl, de
	ld (hl), $00
	add hl, de
	ld (hl), $00
	add hl, de
	ld (hl), $00
	add hl, de
	ld (hl), $00
	add hl, de
	ld (hl), $00
	add hl, de
	ld (hl), $00
	add hl, de
	ld (hl), $00
	jr DPMF

DPMF:
	inc c
	ld a, c
	cp 16
	JUMP_NZ(DPMStart)
	inc b
	ld c, 0
	ld a, b
	cp (ix)		  ; (ix) is PuyoMaxY
	JUMP_NZ(DPMStart) ; if it's not yet 8, it's not done

	
	
	


	
	
	
	
	
 	pop ix
	pop hl
	pop de
	pop bc
	ret

CreateNewPuyo: 
	push bc
	push de
	push hl

	
	ld a,  (RANDOMNUMBER)
	ld h, a
	ld l, a
	ld a, (hl)
	add a, 01100111b
	ld (RANDOMNUMBER), a ; get a random address, and put what's in there to seed again
	ld a, (RANDOMNUMBER)
	ld c, a
	ld b, a
	sra c
	sra c
	sra c
	sra c
	ld a, c
	and 00000011b
	ld c, a
	ld a, b
	and 00000011b
	ld b, a

	ld de, (PROGRAM_ADDR)
	ld hl, PuyoMaxY
	add hl, de
	ld a, (hl) ; this will be the max y value
	sra a	   ; this will divide it by two, giving us the middle of the screen
	
	push af
	push bc
	ld c, a
	ld b, 15
	CALL_(CheckPuyo)
	cp 255
	CALL_NZ(GameOver) ;if it's not empty, it's game over
	ld b, 14
	CALL_(CheckPuyo)
	cp 255
	CALL_NZ(GameOver)
	
	CALL_(DropOjama)
	
	pop bc
	pop af
	
	

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld (hl), 15
	ld hl, Puyo1Y
	add hl, de
	ld (hl), a
	ld hl, Puyo1Type
	add hl, de
	ld (hl), b

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2X
	add hl, de
	ld (hl), 14
	ld hl, Puyo2Y
	add hl, de
	ld (hl), a
	ld hl, Puyo2Type
	add hl, de
	ld (hl), c

	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)

	pop hl
	pop de
	pop bc
	ret

CheckPuyo:  ; input: b-x value c- y value output: a- type of puyo there (zero for none)
	    ; if output is 255, nothing there, if it is 254, it is an illegal move
	push bc
	push de
	push hl

	ld de, (PROGRAM_ADDR)
	
	ld a, b
	cp 16	;check if it's below where it should be, if it is, it'll be 255
	jr c, CheckPuyoA	; if not, continue
	ld a, 254		; otherwise, put 254 in a and return
	jr CheckPuyoEnd
	
CheckPuyoA: 
	ld a, c
	cp PUYOMINY	; check if it's under the top of the screen
	jr nc, CheckPuyoB
	ld a, 254
	jr CheckPuyoEnd

CheckPuyoB:
	ld a, c
	ld hl, PuyoMaxY
	add hl, de
	cp (hl)
	jr c, CheckPuyoC
	ld a, 254
	jr CheckPuyoEnd

CheckPuyoC:
	
	ld a, c
	sla a	; shifts left 4 bits, thereby taking y*16
	sla a
	sla a
	sla a
	add a, b ; add the x to the y*16 value 
	ld c, a
	ld b, 0 ; put the added number in bc for later addition
	
	ld hl, (PROGRAM_ADDR)
	ld de, PuyoMatrix
	add hl, de	; get the address of the puyomatrix
	add hl, bc	; add to the spot we need to look at
	ld a, (hl)	; get the puyo type
	
CheckPuyoEnd
	pop hl
	pop de
	pop bc
	
	ret


RotatePuyoRight: 
	push af
	push bc
	push de
	push hl

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	ld hl, Puyo2X
	add hl, de
	ld c, (hl)
	ld a, b
	cp c ;comparing a-the first puyo x address, with c, the second puyo x address

	jr z, RPRCheckRightLeft ; if it's equal, check the y addresses
	jr c, RPRPuyoDown	; if the first puyo is less, it must be down
	

RPRPuyoUp:			;otherwise, it must be up
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	dec b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	inc c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPRSwitch ; if it's not empty, get outta here
	jr RPRMove
	


RPRPuyoDown:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	inc b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	dec c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPRSwitch ; if it's not empty, get outta here
	jr RPRMove

RPRCheckRightLeft:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1Y
	add hl, de
	ld b, (hl)
	ld hl, Puyo2Y
	add hl, de
	ld c, (hl)
	ld a, b
	cp c ;comparing a-the first puyo x address, with c, the second puyo x address

	jr c, RPRPuyoLeft ; if it's less, it's to the left
			  ; otherwise, right
RPRPuyoRight:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	dec b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	dec c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPRSwitch ; if it's not empty, get outta here
	jr RPRMove

RPRPuyoLeft:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	inc b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	inc c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPRSwitch ; if it's not empty, get outta here
	jr RPRMove

RPRMove:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld (hl), b
	ld hl, Puyo1Y
	add hl, de
	ld (hl), c
	jr RPREnd
RPRSwitch:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1Type
	add hl, de
	ld ix, Puyo2Type
	add ix, de
	ld a, (hl)
	ld b, a
	ld a, (ix)
	ld (hl), a
	ld a, b
	ld (ix), a

RPREnd:
	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)

	pop hl
	pop de
	pop bc
	pop af
	ret
RotatePuyoLeft: 
	push af
	push bc
	push de
	push hl

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	ld hl, Puyo2X
	add hl, de
	ld c, (hl)
	ld a, b
	cp c ;comparing a-the first puyo x address, with c, the second puyo x address

	jr z, RPLCheckRightLeft ; if it's equal, check the y addresses
	jr c, RPLPuyoDown	; if the first puyo is less, it must be down
	

RPLPuyoUp:			;otherwise, it must be up
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	dec b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	dec c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPLSwitch ; if it's not empty, get outta here
	jr RPLMove
	


RPLPuyoDown:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	inc b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	inc c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPLSwitch ; if it's not empty, get outta here
	jr RPLMove

RPLCheckRightLeft:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1Y
	add hl, de
	ld b, (hl)
	ld hl, Puyo2Y
	add hl, de
	ld c, (hl)
	ld a, b
	cp c ;comparing a-the first puyo x address, with c, the second puyo x address

	jr c, RPLPuyoLeft ; if it's less, it's to the left
			  ; otherwise, right
RPLPuyoRight:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	inc b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	dec c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPLSwitch ; if it's not empty, get outta here
	jr RPLMove

RPLPuyoLeft:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	dec b
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	inc c
	CALL_(CheckPuyo)
	cp 255
	jr nz, RPLSwitch ; if it's not empty, get outta here
	jr RPLMove

RPLMove:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld (hl), b
	ld hl, Puyo1Y
	add hl, de
	ld (hl), c
	jr RPLEnd
RPLSwitch:
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1Type
	add hl, de
	ld ix, Puyo2Type
	add ix, de
	ld a, (hl)
	ld b, a
	ld a, (ix)
	ld (hl), a
	ld a, b
	ld (ix), a

RPLEnd:
	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)
	pop hl
	pop de
	pop bc
	pop af
	ret

FallingPRight:
	push af
	push bc
	push de
	push hl

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	inc c	; now b has the x value, and c the incremented y value, so we can test
	CALL_(CheckPuyo)
	cp 255
	jr NZ, FallingPRightEnd ;if it's not empty, get outta here

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2X
	add hl, de
	ld b, (hl)
	ld hl, Puyo2Y
	add hl, de
	ld c, (hl)
	inc c	; now b has the x value, and c the incremented y value, so we can test
	CALL_(CheckPuyo)
	cp 255
	jr NZ, FallingPRightEnd ;if it's not empty, get outta here


	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1Y
	add hl, de
	inc (hl)

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2Y
	add hl, de
	inc (hl)

FallingPRightEnd:
	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)
	
	pop hl
	pop de
	pop bc
	pop af
	ret

FallingPLeft:
	push af
	push bc
	push de
	push hl

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	dec c	; now b has the x value, and c the decremented y value, so we can test
	CALL_(CheckPuyo)
	cp 255
	jr NZ, FallingPLeftEnd ;if it's not empty, get outta here

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2X
	add hl, de
	ld b, (hl)
	ld hl, Puyo2Y
	add hl, de
	ld c, (hl)
	dec c	; now b has the x value, and c the decremented y value, so we can test
	CALL_(CheckPuyo)
	cp 255
	jr NZ, FallingPLeftEnd ;if it's not empty, get outta here

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1Y
	add hl, de
	dec (hl)

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2Y
	add hl, de
	dec (hl)

FallingPLeftEnd:
	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)
	
	pop hl
	pop de
	pop bc
	pop af
	ret
FallingPGravity:
	push af
	push bc
	push de
	push hl
	
	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)
	dec b	; now b has the decremented x value, and c the  y value, so we can test
	CALL_(CheckPuyo)
	cp 255
	jr NZ, FPGSolidify ;if it's not empty, put it in the matrix

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2X
	add hl, de
	ld b, (hl)
	ld hl, Puyo2Y
	add hl, de
	ld c, (hl)
	dec b	; now b has the decremented x value, and c the y value, so we can test
	CALL_(CheckPuyo)
	cp 255
	jr NZ, FPGSolidify ;if it's not empty, put it in the matrix
	jr FallingPGravityA ;otherwise, continue on

FPGSolidify:

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo1X
	add hl, de
	ld b, (hl)
	ld hl, Puyo1Y
	add hl, de
	ld c, (hl)

	sla c
	sla c
	sla c
	sla c
	ld a, c
	add a, b
	ld b, 0
	ld c, a ; so we can add bc later to puyoMatrix and PROGRAM_ADDR
	ld hl, PuyoMatrix
	add hl, de
	add hl, bc
	ld b, h
	ld c, l ; so later we can put the type into this address

	ld hl, Puyo1Type
	add hl, de
	ld a, (hl)
	ld (bc), a ; put the type into the address in the PuyoMatrix

	ld de, (PROGRAM_ADDR)
	ld hl, Puyo2X
	add hl, de
	ld b, (hl)
	ld hl, Puyo2Y
	add hl, de
	ld c, (hl)

	sla c
	sla c
	sla c
	sla c
	ld a, c
	add a, b
	ld b, 0
	ld c, a ; so we can add bc later to puyoMatrix and PROGRAM_ADDR
	ld hl, PuyoMatrix
	add hl, de
	add hl, bc
	ld b, h
	ld c, l ; so later we can put the type into this address

	ld hl, Puyo2Type
	add hl, de
	ld a, (hl)
	ld (bc), a ; put the type into the address in the PuyoMatrix
	
	CALL_(PuyoGravity) ; make sure everything falls
	push hl
	CALL_(PuyoComboMatrix)   ; check for combos
	pop hl
	
	CALL_(CreateNewPuyo) ; create new puyo set
	jr FallingPGravityEnd ; and leave



FallingPGravityA:
	
	ld hl, (PROGRAM_ADDR)
	ld b, h
	ld c, l
	ld de, Puyo1X
	add hl, de
	dec (hl)

	ld h, b
	ld l, c
	ld de, Puyo2X
	add hl, de
	dec (hl)

FallingPGravityEnd:
	CALL_(DisplayPMatrix)
	
	CALL_(DisplayFallingP)

	pop hl
	pop de
	pop bc
	pop af
	ret

DisplayFallingP:
	push bc
	push de
	push hl
	ld hl,  (PROGRAM_ADDR)
	ld b, h
	ld c, l
	ld de, Puyo1Y
	add hl, de
	ld a, (hl)
	ld de, 0
	srl a
	jr nc, DisplayFallingPuyoA ; the carry will have the bit shifted out
			          ; so if there were a carry, 
	ld e, 128		          ; we put a 1 in bit 7
DisplayFallingPuyoA
	ld d, a

	ld h, b
	ld l, c
	push de
	ld de, Puyo1X
	add hl, de
	pop de
	ld a, (hl)
	ld h, 0
	ld l, a
	add hl, de
	ld de, VIDEO_MEM
	add hl, de   ; hl should contain spot in video of the puyo
	push hl
	ld de, Puyo1Type
	ld hl, (PROGRAM_ADDR)
	add hl, de
	ld a, (hl)
	pop hl
	cp 0
	jr z, dp1
	cp 1
	jr z, dp2
	cp 2
	JUMP_Z(dp3)
	cp 3
	JUMP_Z(dp4)

dp1:
		push hl 
		ld hl, Puyo1Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp1a:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp1a
		JUMP_(dpend)
dp2:
		push hl 
		ld hl, Puyo2Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp2a:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp2a
		jr dpend

dp3:
		push hl 
		ld hl, Puyo3Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp3a:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp3a
		jr dpend

dp4:
		push hl 
		ld hl, Puyo4Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp4a:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp4a
		jr dpend

dpend:

	ld hl,  (PROGRAM_ADDR)
	ld b, h
	ld c, l
	ld de, Puyo2Y
	add hl, de
	ld a, (hl)
	ld de, 0
	srl a
	jr nc, DisplayFallingPuyoAb ; the carry will have the bit shifted out
			          ; so if there were a carry, 
	ld e, 128		          ; we put a 1 in bit 7
DisplayFallingPuyoAb
	ld d, a

	ld h, b
	ld l, c
	push de
	ld de, Puyo2X
	add hl, de
	pop de
	ld a, (hl)
	ld h, 0
	ld l, a
	add hl, de
	ld de, VIDEO_MEM
	add hl, de   ; hl should contain spot in video of the puyo
	push hl
	ld de, Puyo2Type
	ld hl, (PROGRAM_ADDR)
	add hl, de
	ld a, (hl)
	pop hl
	cp 0
	jr z, dp1b
	cp 1
	jr z, dp2b
	cp 2
	JUMP_Z(dp3b)
	cp 3
	JUMP_Z(dp4b)

dp1b:
		push hl 
		ld hl, Puyo1Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp1ab:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp1ab
		jr dpendb
dp2b:
		push hl 
		ld hl, Puyo2Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp2ab:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp2ab
		jr dpendb
dp3b:
		push hl 
		ld hl, Puyo3Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp3ab:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp3ab
		jr dpendb
dp4b:
		push hl 
		ld hl, Puyo4Graphic
		add hl, bc
		ld d, h
		ld e, l
		pop hl
		ld b, 8
dp4ab:		ld a, (de)
		ld (hl), a
		inc de
		push de
		ld de, 16
		add hl, de
		pop de
		dec b
		ld a, b
		cp 0
		jr nz, dp4ab
		jr dpendb

dpendb:
	pop hl
	pop de
	pop bc
	ret
	

;FadeOut: ; this is commented out because it is not emulated so I can't tell if it works
;	push bc	; I believe it does, but am not sure, so I left it out of the program
;	push de
;	push hl
;	ld b, 255
;	ld c, 255
;FadeOutA:	
;	ld a, (CONTRAST) 
;	dec a
;	ld (CONTRAST), a
;FadeOutB:
;	push bc
;	pop bc
;	push bc
;	pop bc
;	push bc
;	pop bc
;	push bc
;	pop bc
;	dec bc
;	ld a, 0
;	cp c
;	JUMP_NZ(FadeOutB)
;	cp b
;	JUMP_NZ(FadeOutB)
;	ld a, (CONTRAST)
;	cp 0
;	JUMP_NZ(FadeOutA)
;	pop hl
;	pop de
;	pop bc
;	ret


ClearScreen:
	push hl
	ld hl, VIDEO_MEM
	ld (hl), 0
	ld a, 255
ClearScreenA:
	inc hl
	ld (hl), 0
	cp l
	jr nz, (ClearScreenA)
	cp h
	jr nz, (ClearScreenA)
	pop hl
	ret
TitleText1: .db "Puyo Puyo by Kinkachou", 0
HighScoreText:  .db "Highscore:", 0
ScoreText: .db "    score:", 0
ClearScreenText:  .db "To start over, press clear", 0
SpeedText:  .db "Speed:", 0
SpeedText2: .db "To speed up, press -"
SpeedText3: .db "To slow down, press +"
WidthText:  .db "Width:"
ContinueText: .db "To continue, press enter"
GameOverText:  .db 10, "Game Over!"
PuyoSpeed:  .db 128
OjamaNumber: .db 0

Puyo1Graphic: .db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
Puyo1X: .db $0f
Puyo1Y: .db $03
Puyo1Type: .db $02
Puyo2Type: .db $03
Puyo2Graphic: .db $c3, $e7, $3c, $18, $18, $3c, $e7, $c3
Puyo3Graphic: .db $18, $3c, $66, $c3, $c3, $66, $3c, $18
Puyo4Graphic: .db $00, $7e, $42, $42, $42, $42, $7e, $00
Puyo5Graphic: .db $aa, $55, $aa, $55, $aa, $55, $aa, $55
Puyo2X: .db $0e
Puyo2Y: .db $03
HighScore: .db $00, $00
HighestScore: .db $00, $00
PuyoMaxY:  .db 8
PuyoMatrix: .db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
	.db $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
.end

